unit F_Kill;
{ ** F_Kill.pas
  ** Programme d'exemple de l'utilisation de l'unit u_kill.pas
  ** Fait avec Delphi 3
  ** Sample program for unit u_kill.pas
  ** made with Delphi 3
  **}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TFKill = class(TForm)
    lbTask: TListBox;
    Panel: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Timer: TTimer;
    Label1: TLabel;
    procedure TimerTimer(Sender: TObject);
    procedure lbTaskClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FKill: TFKill;

implementation

{$R *.DFM}
uses
  u_kill;
procedure TFKill.TimerTimer(Sender: TObject);
// On each tick of the timer (every 1000ms)
// we collect pid/process info
var
  task : TStringList; // string for the result. The task name is task[i], the pid is integer(task.Objects[i]);
  select : integer;   // the selected index in the listbox
begin
  task := TStringList.Create;
  Timer.Enabled := false;
  try
    EnumProcessWithPid(task);
    select := lbTask.ItemIndex;
    lbTask.Items := task; // fill the list box with the result
    lbTask.ItemIndex := select;
  finally
    task.Free
  end;
  Timer.Enabled := true;
end;

procedure TFKill.lbTaskClick(Sender: TObject);
var
  pid : integer;
  select : integer;
begin
  select := lbTask.ItemIndex;
  if (select <> -1) then
  begin
    pid := integer(lbTask.Items.Objects[select]);
    Panel.Caption := Format('PID=%d', [pid])
  end;
end;

procedure TFKill.BitBtn1Click(Sender: TObject);
var
  pid : integer;
  select : integer;
begin
  select := lbTask.ItemIndex;
  if (select <> -1) then
  begin
    pid := integer(lbTask.Items.Objects[select]);
    Kill_By_Pid(pid);
    Panel.Caption := 'Killed !';
    Timer.Enabled := false; // restart timer
    Timer.Enabled := true;
  end;
end;

end.
